/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controlador;

import Persistencia.CursoFacadeLocal;
import Persistencia.DiffusuarioFacadeLocal;
import Persistencia.EntregausuarioFacadeLocal;
import Persistencia.MatriculaFacadeLocal;
import Persistencia.UsuarioFacadeLocal;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author aleja
 */
public class Tutorial extends HttpServlet {
    @EJB
    private UsuarioFacadeLocal usuarioFacade;
    @EJB
    private EntregausuarioFacadeLocal entregausuarioFacade;
    @EJB
    private DiffusuarioFacadeLocal diffusuarioFacade;
    @EJB
    private MatriculaFacadeLocal matriculaFacade;
    @EJB
    private CursoFacadeLocal cursoFacade;

    /**
     * Maneja los tutoriales
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        HttpSession session = request.getSession();

        if (request.getParameter("hide") != null) {
            // MODO OCULTAR TUTORIAL

            // Comprobar por seguridad que no sea un alumno
            Dominio.Usuario user = (Dominio.Usuario) session.getAttribute("user");
            if (user.getRol().getId() <= 1) {
                // Obtener el objeto curso de esa ID
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));
                
                if(curso == null){
                    //ERROR
                    RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                    rd.forward(request, response);
                }

                // Si estaba activo lo desactiva y viceversa
                curso.setActivo(!curso.getActivo());

                // Guardar el curso en la BD
                cursoFacade.edit(curso);

                //Redirige a la página de inicio
                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
            }else{
                // Si no el usuario no tiene permisos se le redirige a la página de error
                RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                rd.forward(request, response);
            }
        } else if (request.getParameter("up") != null) {
            // MODO MOVER TUTORIAL
            
            // Comprobar por seguridad que no sea un alumno
            Dominio.Usuario user = (Dominio.Usuario) session.getAttribute("user");
            if (user.getRol().getId() <= 1) {
                
                // Obtener el curso a mover
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));
                List<Dominio.Curso> cursos = cursoFacade.findAll();
                
                // Se le suma una posición al curso anterior
                for (Dominio.Curso c : cursos) {
                    if (c.getNumero() == curso.getNumero() - 1) {
                        // c es el curso anterior al que queremos mover
                        c.setNumero(c.getNumero() + 1);
                        cursoFacade.edit(c);
                        break;
                    }
                }
                
                // Se reduce una posición al curso que quería subir
                curso.setNumero(curso.getNumero() - 1);
                cursoFacade.edit(curso);

                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
            }else{
                // Si no el usuario no tiene permisos se le redirige a la página de error
                RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                rd.forward(request, response);
            }
        } else if (request.getParameter("down") != null) {
            // MODO MOVER TUTORIAL
            // Comprobar por seguridad que no sea un alumno
            Dominio.Usuario user = (Dominio.Usuario) session.getAttribute("user");
            if (user.getRol().getId() <= 1) {
                
                // Obtener el curso a mover
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));
                List<Dominio.Curso> cursos = cursoFacade.findAll();
                
                // Se le resta una posición al curso siguente
                for (Dominio.Curso c : cursos) {
                    if (c.getNumero() == curso.getNumero() + 1) {
                        // c es el curso posterior al que queremos mover
                        c.setNumero(c.getNumero() - 1);
                        cursoFacade.edit(c);
                        break;
                    }
                }

                // Se aumenta una posición al curso que quería bajar
                curso.setNumero(curso.getNumero() + 1);
                cursoFacade.edit(curso);

                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
            }else{
                // Si no el usuario no tiene permisos se le redirige a la página de error
                RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                rd.forward(request, response);
            }
        }
        if (request.getParameter("end") != null) {
            // MODO FINALIZAR TUTORIAL

            // Obtener el objeto curso de esa ID
            Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));

            // Comprobar por seguridad que no sea un alumno intentando finalizar
            // un curso oculto
            Dominio.Usuario user = (Dominio.Usuario) session.getAttribute("user");
            if (curso!=null && (curso.getActivo() || user.getRol().getId() <= 1)) {

                // Obtener matrícula del usuario
                Dominio.MatriculaPK matriculaPK = new Dominio.MatriculaPK(user.getLogin(), curso.getId());
                Dominio.Matricula matricula = matriculaFacade.find(matriculaPK);
                
                // Fijar matricula como finalizada
                matricula.setCompletado(true);

                // Guardar matrícula
                matriculaFacade.edit(matricula);
                
                // Guardar la matricula en la collection del usuario para 
                //sobreescribir el mecanismo de caché de JPA
                Collection<Dominio.Matricula> matriculas = user.getMatriculaCollection();
                for(Dominio.Matricula m : matriculas){
                    if(m.getCurso().getId().equals(curso.getId()))
                        m.setCompletado(true);
                }               
                user.setMatriculaCollection(matriculas);
                usuarioFacade.edit(user);
                
                // Guardar la matricula en la collection del curso para 
                //sobreescribir el mecanismo de caché de JPA
                matriculas = curso.getMatriculaCollection();
                for(Dominio.Matricula m : matriculas){
                    if(m.getUsuario().getLogin().equals(user.getLogin()))
                        m.setCompletado(true);
                }
                curso.setMatriculaCollection(matriculas);
                cursoFacade.edit(curso);

                // Redirigir a la página principal
                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
            }else{
                // Si no el usuario no tiene permisos se le redirige a la página de error
                RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                rd.forward(request, response);
            }
        } else {
            // MODO EMPEZAR TUTORIAL

            // Obtener el objeto curso de esa ID
            Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));

            // Comprobar por seguridad que no sea un alumno intentando entrar
            // a un curso oculto
            Dominio.Usuario user = (Dominio.Usuario) session.getAttribute("user");
            if (curso!=null && (curso.getActivo() || user.getRol().getId() <= 1)) {

                // Obtener la página solicitada (por defecto la primera)
                int page;
                if (request.getParameter("page") == null) {
                    page = 1;
                } else {
                    page = Integer.parseInt(request.getParameter("page"));
                }

                // Obtener los apartados (teoria y codigo) del curso
                Collection<Dominio.Apartado> apartados = curso.getApartadoCollection();

                // Comprobar de qué tipo son los apartados
                Dominio.Apartado apartado = null;
                for (Dominio.Apartado a : apartados) {
                    if (a.getOrden() == page) {
                        if (a.getTeoria() != null) {
                            // El apartado es de teoria
                            request.setAttribute("teoria", a.getTeoria());
                        }

                        if (a.getCodigo() != null) {
                            // El apartado es de codigo
                            request.setAttribute("code", a.getCodigo().getCodigo());
                            request.setAttribute("aptdo_code", a.getId());
                        }

                        if (a.getEntrega() != null) {
                            // El apartado es de entrega
                            request.setAttribute("entrega", "true");
                            
                            // Buscar una entrega anterior, si existe mostrar ese código, 
                            // si no, mostrar el código inicial 
                            Dominio.EntregausuarioPK entregausuariopk = new Dominio.EntregausuarioPK(user.getLogin(), a.getId());
                            Dominio.Entregausuario entregausuario = entregausuarioFacade.find(entregausuariopk);
                            if(entregausuario!=null){
                                request.setAttribute("code", entregausuario.getCodUsuario());    
                                request.setAttribute("realizado", true);
                            }else
                                request.setAttribute("code", a.getEntrega().getCodInicial());                            
                            
                            request.setAttribute("aptdo_code", a.getId());
                            apartado = a;
                        }
                        
                        if (a.getDiff() != null) {
                            // El apartado es un comprobante
                            request.setAttribute("diff", "true");
                            request.setAttribute("code", a.getDiff().getCodInicial());                            
                            request.setAttribute("aptdo_code", a.getId());
                            apartado = a;

                            // Crear diffusuario si no existía
                            Dominio.DiffusuarioPK diffusuariopk = new Dominio.DiffusuarioPK(user.getLogin(), a.getId());
                            Dominio.Diffusuario diffuser = diffusuarioFacade.find(diffusuariopk);
                            if (diffuser == null) {
                                // FIjar datos
                                Dominio.Diffusuario diffusuario = new Dominio.Diffusuario();
                                diffusuario.setDiffusuarioPK(diffusuariopk);
                                diffusuario.setCorrecto(false);

                                // Guardar en la BD
                                diffusuarioFacade.create(diffusuario);
                                
                                // Guardar el objeto en la collection del usuario para
                                // sobreescribir el mecanismo de caché de JPA
                                Collection<Dominio.Diffusuario> diffs_usr = user.getDiffusuarioCollection();
                                diffusuario.setDiff(a.getDiff());
                                diffusuario.setUsuario(user);
                                diffs_usr.add(diffusuario);
                                List list = new ArrayList(diffs_usr);
                                Collections.sort(list, (Dominio.Diffusuario d1, Dominio.Diffusuario d2) -> d1.getDiff().getIdAptdo().compareTo(d2.getDiff().getIdAptdo()));
                                user.setDiffusuarioCollection(list);
                                usuarioFacade.edit(user);
                            }else{
                                // Si el usuario ya realizó correctamente el apartado
                                if(diffuser.getCorrecto()==true)
                                    request.setAttribute("realizado", true);
                            }
                        }
                    }
                }
                request.setAttribute("curso", curso);

                // Crear matricula para seguimiento del alumno (si no existe)
                Dominio.MatriculaPK matriculaPK = new Dominio.MatriculaPK(user.getLogin(), curso.getId());
                if (matriculaFacade.find(matriculaPK) == null) {
                    // Fijar los datos de la matrícula
                    Dominio.Matricula matricula = new Dominio.Matricula();
                    matricula.setMatriculaPK(matriculaPK);
                    // Empieza como no completada
                    matricula.setCompletado(false);
                    matricula.setCurso(curso);
                    matricula.setUsuario(user);
                    
                    // Guardar en la BD
                    matriculaFacade.create(matricula);

                    
                    // Guardar en la collection del usuario para
                    // sobreescribir el mecanismo de caché de JPA
                    Collection<Dominio.Matricula> matriculas = user.getMatriculaCollection();
                    matriculas.add(matricula);
                    List list = new ArrayList(matriculas);
                    Collections.sort(list, (Dominio.Matricula m1, Dominio.Matricula m2) -> m1.getCurso().getId().compareTo(m2.getCurso().getId()));
                    user.setMatriculaCollection(list);
                    usuarioFacade.edit(user);
                    
                    // Guardar en la collection del curso para
                    // sobreescribir el mecanismo de caché de JPA
                    matriculas = curso.getMatriculaCollection();
                    matriculas.add(matricula);
                    list = new ArrayList(matriculas);
                    Collections.sort(list, (Dominio.Matricula m1, Dominio.Matricula m2) -> m1.getUsuario().getLogin().compareTo(m2.getUsuario().getLogin()));
                    curso.setMatriculaCollection(list);
                    cursoFacade.edit(curso);
                }

                if (request.getParameter("edit") != null) {
                    // MODO EDITAR TUTORIAL

                    // Comprobar por seguridad que no sea un alumno
                    if (user.getRol().getId() <= 1) {
                        request.setAttribute("edit", true);
                    }
                } else {

                    if (request.getParameter("diff") != null) {
                        // MODO COMPROBAR EL DIFF
                        String codeUser = request.getParameter("text");

                        // comprobar si el código dado coincide o no
                        if (codeUser.equals(apartado.getDiff().getCodCorrecto())) {
                            // La respuesta fue correcta
                            request.setAttribute("diffcorrect", "true");

                            // Modificar su diffusuario para marcarlo como correcto
                            Dominio.DiffusuarioPK diffusuariopk = new Dominio.DiffusuarioPK(user.getLogin(), apartado.getId());
                            Dominio.Diffusuario diffusuario = diffusuarioFacade.find(diffusuariopk);
                            diffusuario.setCorrecto(true); // Codigo correcto
                            
                            // Guardar en la BD
                            diffusuarioFacade.edit(diffusuario);
                            
                            // Se guarda en el collection del usuario para
                            // sobreescribir el mecanismo de caché de JPA
                            Collection<Dominio.Diffusuario> diffs_usr = user.getDiffusuarioCollection();
                            for(Dominio.Diffusuario du : diffs_usr){
                                if(du.getDiff().equals(apartado.getDiff())){
                                    du.setCorrecto(true);
                                }
                            }
                            user.setDiffusuarioCollection(diffs_usr);
                            usuarioFacade.edit(user);
                            
                        }else
                            // Respuesta incorrecta
                            request.setAttribute("diffincorrect", "true");

                        request.setAttribute("scripts", codeUser);

                        // Para saltarse la protección de algunos navegadores de 
                        // enviar y recibir condigo javascript
                        response.setHeader("X-XSS-Protection", "0");
                    }

                    if (request.getParameter("entrega") != null) {
                        // MODO SUBIR LA ENTREGA
                        String codeUser = request.getParameter("text");

                        // Se crea un nuevo objeto entregausuario para guardar su entrega
                        Dominio.EntregausuarioPK entregausuariopk = new Dominio.EntregausuarioPK(user.getLogin(), apartado.getId());

                        if (entregausuarioFacade.find(entregausuariopk) == null) {
                            // Si no existe, se crea
                            
                            // Fijar los datos
                            Dominio.Entregausuario entregausuario = new Dominio.Entregausuario();
                            entregausuario.setEntregausuarioPK(entregausuariopk);
                            entregausuario.setCodUsuario(codeUser);
                            
                            // Guardar en la BD
                            entregausuarioFacade.create(entregausuario);
                            
                            // Se guarda en la collection del usuario para
                            // sobreescribir el mecanismo de caché de JPA
                            Collection<Dominio.Entregausuario> entregas_usr = user.getEntregausuarioCollection();
                            entregausuario.setEntrega(apartado.getEntrega());
                            entregausuario.setUsuario(user);
                            entregas_usr.add(entregausuario);
                            List list = new ArrayList(entregas_usr);
                            Collections.sort(list, (Dominio.Entregausuario e1, Dominio.Entregausuario e2) -> e1.getEntrega().getIdAptdo().compareTo(e2.getEntrega().getIdAptdo()));
                            user.setEntregausuarioCollection(list);
                            usuarioFacade.edit(user);
                            
                        } else {
                            // Si existe, se modifica
                            
                            // Se fijan los nuevos datos
                            Dominio.Entregausuario entregausuario = entregausuarioFacade.find(entregausuariopk);
                            entregausuario.setCodUsuario(codeUser);

                            // Se guardan en la BD
                            entregausuarioFacade.edit(entregausuario);
                            
                            // Se modifica también en la collection del usuario para
                            // sobreescribir el mecanismo de caché de JPA
                            Collection<Dominio.Entregausuario> entregas_usr = user.getEntregausuarioCollection();
                            for(Dominio.Entregausuario e : entregas_usr){
                                if(e.getEntrega().equals(apartado.getEntrega())){
                                    e.setCodUsuario(codeUser);
                                }
                            }
                            user.setEntregausuarioCollection(entregas_usr);
                            usuarioFacade.edit(user);
                        }

                        request.setAttribute("entregacorrect", "true");

                        request.setAttribute("scripts", codeUser);

                        // Para saltarse la protección de algunos navegadores de 
                        // enviar y recibir condigo javascript
                        response.setHeader("X-XSS-Protection", "0");

                    }
                }

                if (request.getParameter("execute") != null) {
                    // MODO EJECUTAR CODIGO
                    String script = request.getParameter("text");
                    request.setAttribute("scripts", script);

                    // Para saltarse la protección de algunos navegadores de 
                    // enviar y recibir condigo javascript
                    response.setHeader("X-XSS-Protection", "0");
                }

                // redirigir a la página del tutorial
                RequestDispatcher rd = request.getRequestDispatcher("tutorial.jsp");
                rd.forward(request, response);
            } else {

                // Si el usuario no tiene permiso, se redirige a la página de error
                RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                rd.forward(request, response);
            }
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
