<!--Header-->
<%@ include file="/includes/header.jsp" %>

<!--Barra de navegacin-->
<%@ include file="/includes/nav.jsp" %>


<!--Pgina-->
<%@ page import="Dominio.Curso" %>
<%@ page import="Dominio.Apartado" %>
<%@ page import="Dominio.Diffusuario" %>
<%@ page import="Dominio.Entregausuario" %>
<%@ page import="Dominio.Matricula" %>
<% List<Usuario> alumnos = (List<Usuario>) request.getAttribute("alumnos");
Curso curso = (Curso) request.getAttribute("curso");
List<Apartado> apartados = (List<Apartado>) request.getAttribute("apartados");
Collection<Matricula> matriculas = curso.getMatriculaCollection();%>


<div class="container">
    <div class="row">
        <div class="col-md-12">
            <!--NOMBRE DEL TUTORIAL-->
            <h4>Tutorial n<%=curso.getNumero()%> : <%=curso.getNombre()%></h4>
            <div class="table-responsive">

                <!--TABLA LISTADO DE ALUMNOS-->
                <table id="mytable" class="table table-striped">

                    <!--Cabecera-->
                    <thead>
                        <th>Alumno</th>
                        <th>Perfil</th>
                        <th>Estado</th>
                        <%if(apartados.size() != 0){%>
                            <%for(int i = 0; i < apartados.size(); i++){%>
                                <%if(apartados.get(i).getDiff() != null){%>
                                    <th>Comprobante</br>pag <%=apartados.get(i).getOrden()%></th>
                                <%}else if(apartados.get(i).getEntrega() != null){%>    
                                    <th>Entrega</br>pag <%=apartados.get(i).getOrden()%></th>
                                <%}%>
                            <%}%>
                            <th>Nota</th>
                        <%}%>
                    </thead>
                    
                    <!--Cuerpo de la tabla-->
                    <tbody>
                        
                        <%for(int i = 0; i < alumnos.size(); i++){%>
                            <tr>
                                <td><%=alumnos.get(i).getNombre()%> <%=alumnos.get(i).getApellidos()%></td>
                                <td><a href="profile?login=<%=alumnos.get(i).getLogin()%>" class="btn btn-primary btn-xs" data-toggle="tooltip" title="Ver perfil del alumno"><span class="glyphicon glyphicon-user"></span></a></td>
                                
                                <%boolean matricula_existe = false;
                                int score = -1;
                                for(Matricula m : matriculas){
                                    if(m.getUsuario().getLogin().equals(alumnos.get(i).getLogin())){
                                        if(m.getCompletado()){%>
                                            <!--FINALIZADO-->
                                            <td><span class="label label-success" data-toggle="tooltip" title="El alumno ha completado el tutorial">Completado</span></td>
                                        <%}else{%>
                                            <!--NO FINALIZADO-->
                                            <td><span class="label label-warning" data-toggle="tooltip" title="El alumno ha empezado el tutorial pero no le ha finalizado">No completado</span></td>
                                        <%}
                                        matricula_existe = true;
                                        if(m.getNota()!=null){
                                            score = m.getNota();
                                        }
                                        break;
                                    }
                                }
                                if(matricula_existe == false){%>
                                    <!--NO COMENZADO-->
                                    <td><span class="label label-danger" data-toggle="tooltip" title="El alumno no ha comenzado el tutorial">Sin comenzar</span></td>
                                <%}%>
                                                                
                              <%Collection<Diffusuario> diffs_usr = alumnos.get(i).getDiffusuarioCollection();
                                Collection<Entregausuario> entregas_usr = alumnos.get(i).getEntregausuarioCollection();
                                for(int j = 0; j < apartados.size(); j++){
                                    // DIFF
                                    if(apartados.get(j).getDiff() != null){
                                        boolean diff_correcto = false;
                                        for(Diffusuario d : diffs_usr){
                                            if(d.getDiff().getIdAptdo() == apartados.get(j).getId()){
                                                if(d.getCorrecto())
                                                    diff_correcto = true;
                                            }
                                        }
                                        if(diff_correcto){%>
                                            <!--COMPROBANTE CORRECTO-->
                                            <td><i class="glyphicon glyphicon-ok-circle text-success"  data-toggle="tooltip" title="El codigo fue correcto"></i></td>
                                        <%}else{%>
                                            <!--COMPROBANTE INCORRECTO-->
                                            <td><i class="glyphicon glyphicon-remove-circle text-danger"  data-toggle="tooltip" title="El codigo fue incorrecto"></i></td>
                                        <%}
                                    }//ENTREGA
                                    else if(apartados.get(j).getEntrega() != null){
                                        boolean entrega_existe = false;
                                        for(Entregausuario e : entregas_usr){
                                            if(e.getEntrega().getIdAptdo() == apartados.get(j).getId())
                                                entrega_existe = true;
                                        }
                                        if(entrega_existe){%>
                                            <!--VER ENTREGA-->
                                            <td><p data-placement="top"><a href="progress?entrega=<%=apartados.get(j).getId()%>&login=<%=alumnos.get(i).getLogin()%>" class="btn btn-primary btn-xs"><span class="glyphicon glyphicon-download"  data-toggle="tooltip" title="Ver entrega del alumno"></span></a></p></td>
                                        <%}else{%>
                                            <!--NO ENTREGADO-->
                                            <td><p data-placement="top"><a href="#" class="btn btn-primary btn-xs disabled"><span class="glyphicon glyphicon-download" data-toggle="tooltip" title="El alumno no ha realizado la entrega"></span></a></p></td>
                                        <%}
                                    }
                                }%>
                                
                                <!--CALIFICACIN-->                                
                                <%if(apartados.size() != 0){%>
                                    <td>
                                        <%if(matricula_existe == true){%>
                                            <div class="btn-group">
                                                <%if(score >= 0 && score < 5){%>
                                                    <span class="label label-danger dropdown-toggle" data-toggle="dropdown" aria-haspopup="true">Suspenso - <%=score%> <span class="caret"></span> </span>
                                                <%}else if(score == 5){%>
                                                    <span class="label label-warning dropdown-toggle" data-toggle="dropdown" aria-haspopup="true">Aprobado - <%=score%> <span class="caret"></span> </span>
                                                <%}else if(score == 6){%>
                                                    <span class="label label-info dropdown-toggle" data-toggle="dropdown" aria-haspopup="true">Bien - <%=score%> <span class="caret"></span> </span>
                                                <%}else if(score >= 7 && score < 9){%>
                                                    <span class="label label-primary dropdown-toggle" data-toggle="dropdown" aria-haspopup="true">Notable - <%=score%> <span class="caret"></span> </span>
                                                <%}else if(score >= 9){%>
                                                    <span class="label label-success dropdown-toggle" data-toggle="dropdown" aria-haspopup="true">Sobresaliente - <%=score%> <span class="caret"></span> </span>
                                                <%}else{%>
                                                    <span class="label label-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" >
                                                        Fijar nota <span class="caret"></span>
                                                    </span>
                                                <%}%>
                                                <!--MODIFICAR CALICIFICACIN-->
                                                <ul class="dropdown-menu">
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=0">0</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=1">1</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=2">2</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=3">3</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=4">4</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=5">5</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=6">6</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=7">7</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=8">8</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=9">9</a></li>
                                                    <li><a href="progress?id=<%=curso.getId()%>&login=<%=alumnos.get(i).getLogin()%>&score=10">10</a></li>
                                                </ul>
                                            </div>
                                        <%}else{%>
                                            <span class="label label-default" data-toggle="tooltip" title="El alumno no ha empezado el tutorial, no se puede calificar">No disponible</span>
                                        <%}%>
                                    </td>
                                <%}%>
                            </tr>
                        <%} // Fin bucle alumno%>
                        
                    </tbody>
                </table>

            </div>

        </div>
    </div>
</div>
                        
<script>
    $(document).ready(function(){
        $('[data-toggle="tooltip"]').tooltip();   
    });
</script>    


<!--Footer
<%@ include file="/includes/footer.jsp" %>